diff --git a/gdb/frame.c b/gdb/frame.c
index 93bb7f6..40d1950 100644
--- a/gdb/frame.c
+++ b/gdb/frame.c
@@ -1473,14 +1473,7 @@ get_current_frame (void)
     error (_("No memory."));
   /* Traceframes are effectively a substitute for the live inferior.  */
   if (get_traceframe_number () < 0)
-    {
-      if (ptid_equal (inferior_ptid, null_ptid))
-	error (_("No selected thread."));
-      if (is_exited (inferior_ptid))
-	error (_("Invalid selected thread."));
-      if (is_executing (inferior_ptid))
-	error (_("Target is executing."));
-    }
+    validate_registers_access ();
 
   if (current_frame == NULL)
     {
diff --git a/gdb/gdbthread.h b/gdb/gdbthread.h
index eb7f8b8..d78bdf5 100644
--- a/gdb/gdbthread.h
+++ b/gdb/gdbthread.h
@@ -555,6 +555,11 @@ extern int thread_is_in_step_over_chain (struct thread_info *tp);
 
 extern void thread_cancel_execution_command (struct thread_info *thr);
 
+/* Check if it makes sense to access a register of current thread at
+   this point.  If not, throw an error (e.g., the thread is
+   executing).  */
+extern void validate_registers_access (void);
+
 extern struct thread_info *thread_list;
 
 #endif /* GDBTHREAD_H */
diff --git a/gdb/infrun.c b/gdb/infrun.c
index f9bb411..71ede22 100644
--- a/gdb/infrun.c
+++ b/gdb/infrun.c
@@ -8684,25 +8684,6 @@ signals_info (char *signum_exp, int from_tty)
 		     "to change these tables.\n"));
 }
 
-/* Check if it makes sense to read $_siginfo from the current thread
-   at this point.  If not, throw an error.  */
-
-static void
-validate_siginfo_access (void)
-{
-  /* No current inferior, no siginfo.  */
-  if (ptid_equal (inferior_ptid, null_ptid))
-    error (_("No thread selected."));
-
-  /* Don't try to read from a dead thread.  */
-  if (is_exited (inferior_ptid))
-    error (_("The current thread has terminated"));
-
-  /* ... or from a spinning thread.  */
-  if (is_running (inferior_ptid))
-    error (_("Selected thread is running."));
-}
-
 /* The $_siginfo convenience variable is a bit special.  We don't know
    for sure the type of the value until we actually have a chance to
    fetch the data.  The type can change depending on gdbarch, so it is
@@ -8721,7 +8702,9 @@ siginfo_value_read (struct value *v)
 {
   LONGEST transferred;
 
-  validate_siginfo_access ();
+  /* If we can access registers, so can we access $_siginfo.  Likewise
+     vice versa.  */
+  validate_registers_access ();
 
   transferred =
     target_read (&current_target, TARGET_OBJECT_SIGNAL_INFO,
@@ -8742,7 +8725,9 @@ siginfo_value_write (struct value *v, struct value *fromval)
 {
   LONGEST transferred;
 
-  validate_siginfo_access ();
+  /* If we can access registers, so can we access $_siginfo.  Likewise
+     vice versa.  */
+  validate_registers_access ();
 
   transferred = target_write (&current_target,
 			      TARGET_OBJECT_SIGNAL_INFO,
diff --git a/gdb/testsuite/gdb.base/catch-signal-siginfo-cond.exp b/gdb/testsuite/gdb.base/catch-signal-siginfo-cond.exp
new file mode 100644
index 0000000..f2e7295
--- /dev/null
+++ b/gdb/testsuite/gdb.base/catch-signal-siginfo-cond.exp
@@ -0,0 +1,61 @@
+# Copyright 2015 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Regression test for PR19388.  Make sure we can access $_siginfo in a
+# "catch signal" condition.  A buggy GDB would fail with:
+#
+# (gdb) continue
+# Continuing.
+# Error in testing breakpoint condition:
+# Selected thread is running.
+#
+# Catchpoint 3 (signal SIGUSR1), 0x0000003615e35877 in __GI_raise (sig=10) at raise.c:56
+# 56        return INLINE_SYSCALL (tgkill, 3, pid, selftid, sig);
+# (gdb) FAIL: gdb.base/catch-signal-siginfo-cond.exp: continue
+
+if [target_info exists gdb,nosignals] {
+    verbose "Skipping catch-signal-siginfo-cond.exp because of nosignals."
+    return -1
+}
+
+if { ![supports_get_siginfo_type] } {
+    verbose "Skipping catch-signal-siginfo-cond.exp because of lack of support."
+    return -1
+}
+
+standard_testfile
+
+if { [prepare_for_testing "failed to prepare" "${testfile}" $srcfile {debug}] } {
+    return -1
+}
+
+if ![runto_main] then {
+    fail "Can't run to main"
+    return -1
+}
+
+gdb_breakpoint [gdb_get_line_number "set breakpoint here"]
+
+gdb_test "catch signal"
+
+# It's OK to refer to standard Unix signal numbers 1-15 by number.
+
+# SIGUSR1 == 10.  The catchpoint should not cause a stop.
+gdb_test "condition \$bpnum \$_siginfo.si_signo == 11"
+gdb_test "continue" "set breakpoint here.*" "continue: catchpoint does not trigger"
+
+# This time the catchpoint should cause a stop.
+gdb_test "condition \$bpnum \$_siginfo.si_signo == 10"
+gdb_test "continue" "Catchpoint .*signal SIGUSR1.*" "continue: catchpoint triggers"
diff --git a/gdb/thread.c b/gdb/thread.c
index 7d2232f..c6ee190 100644
--- a/gdb/thread.c
+++ b/gdb/thread.c
@@ -1098,6 +1098,28 @@ finish_thread_state_cleanup (void *arg)
   finish_thread_state (*ptid_p);
 }
 
+/* See gdbthread.h.  */
+
+void
+validate_registers_access (void)
+{
+  /* No selected thread, no registers.  */
+  if (ptid_equal (inferior_ptid, null_ptid))
+    error (_("No thread selected."));
+
+  /* Don't try to read from a dead thread.  */
+  if (is_exited (inferior_ptid))
+    error (_("The current thread has terminated"));
+
+  /* ... or from a spinning thread.  FIXME: This isn't actually fully
+     correct.  It'll allow an user-requested access (e.g., "print $pc"
+     at the prompt) when a thread is not executing for some internal
+     reason, but is marked running from the user's perspective.  E.g.,
+     the thread is waiting for its turn in the step-over queue.  */
+  if (is_executing (inferior_ptid))
+    error (_("Selected thread is running."));
+}
+
 int
 pc_in_thread_step_range (CORE_ADDR pc, struct thread_info *thread)
 {