diff --git a/gdb/frame.c b/gdb/frame.c
index 07fa2bc77d6..3e42aa82398 100644
--- a/gdb/frame.c
+++ b/gdb/frame.c
@@ -269,6 +269,22 @@ frame_stash_invalidate (void)
   htab_empty (frame_stash);
 }
 
+/* Save the currently selected frame.  */
+scoped_restore_selected_frame::scoped_restore_selected_frame ()
+{
+  m_fid = get_frame_id (get_selected_frame (NULL));
+}
+
+/* Restore the currently selected frame.  */
+scoped_restore_selected_frame::~scoped_restore_selected_frame ()
+{
+  frame_info *frame = frame_find_by_id (m_fid);
+  if (frame == NULL)
+    warning (_("Unable to restore previously selected frame."));
+  else
+    select_frame (frame);
+}
+
 /* Flag to control debugging.  */
 
 unsigned int frame_debug;
diff --git a/gdb/frame.h b/gdb/frame.h
index d5800b78c25..2c8f815a4ae 100644
--- a/gdb/frame.h
+++ b/gdb/frame.h
@@ -164,6 +164,22 @@ struct frame_id
   int artificial_depth;
 };
 
+/* Save and restore the currently selected frame.  */
+
+class scoped_restore_selected_frame
+{
+public:
+  scoped_restore_selected_frame ();
+  ~scoped_restore_selected_frame ();
+
+  DISABLE_COPY_AND_ASSIGN (scoped_restore_selected_frame);
+
+private:
+
+  /* The ID of the previously selected frame.  */
+  struct frame_id m_fid;
+};
+
 /* Methods for constructing and comparing Frame IDs.  */
 
 /* For convenience.  All fields are zero.  This means "there is no frame".  */
diff --git a/gdb/stack.c b/gdb/stack.c
index ecf1ee83793..7e377764865 100644
--- a/gdb/stack.c
+++ b/gdb/stack.c
@@ -2019,7 +2019,6 @@ print_frame_local_vars (struct frame_info *frame, int num_tabs,
   struct print_variable_and_value_data cb_data;
   const struct block *block;
   CORE_ADDR pc;
-  struct gdb_exception except = exception_none;
 
   if (!get_frame_pc_if_available (frame, &pc))
     {
@@ -2043,27 +2042,12 @@ print_frame_local_vars (struct frame_info *frame, int num_tabs,
   /* Temporarily change the selected frame to the given FRAME.
      This allows routines that rely on the selected frame instead
      of being given a frame as parameter to use the correct frame.  */
+  scoped_restore_selected_frame restore_selected_frame;
   select_frame (frame);
 
-  TRY
-    {
-      iterate_over_block_local_vars (block,
-				     do_print_variable_and_value,
-				     &cb_data);
-    }
-  CATCH (ex, RETURN_MASK_ALL)
-    {
-      except = ex;
-    }
-  END_CATCH
-
-  /* Restore the selected frame, and then rethrow if there was a problem.  */
-  select_frame (frame_find_by_id (cb_data.frame_id));
-  if (except.reason < 0)
-    throw_exception (except);
-
-  /* do_print_variable_and_value invalidates FRAME.  */
-  frame = NULL;
+  iterate_over_block_local_vars (block,
+				 do_print_variable_and_value,
+				 &cb_data);
 
   if (!cb_data.values_printed)
     fprintf_filtered (stream, _("No locals.\n"));
diff --git a/gdb/testsuite/gdb.base/bt-full.c b/gdb/testsuite/gdb.base/bt-full.c
new file mode 100644
index 00000000000..708dc69b250
--- /dev/null
+++ b/gdb/testsuite/gdb.base/bt-full.c
@@ -0,0 +1,35 @@
+/* This testcase is part of GDB, the GNU debugger.
+
+   Copyright 2018 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+void
+breakpt ()
+{
+  asm ("" ::: "memory");
+}
+
+void
+func ()
+{
+  breakpt ();
+}
+
+int
+main ()
+{
+  func ();
+  return 0;
+}
diff --git a/gdb/testsuite/gdb.base/bt-full.exp b/gdb/testsuite/gdb.base/bt-full.exp
new file mode 100644
index 00000000000..7b64293dcfb
--- /dev/null
+++ b/gdb/testsuite/gdb.base/bt-full.exp
@@ -0,0 +1,60 @@
+# Copyright 2018 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+standard_testfile
+
+if { [prepare_for_testing "failed to prepare" $testfile $srcfile debug] } {
+    return -1
+}
+
+if ![runto_main] then {
+    fail "can't run to main"
+    return 0
+}
+
+gdb_breakpoint "breakpt"
+gdb_continue_to_breakpoint "breakpt"
+
+# Return the frame number for the currently selected frame
+proc get_current_frame_number {{test_name ""}} {
+    global gdb_prompt
+
+    if { $test_name == "" } {
+	set test_name "get current frame number"
+    }
+    set frame_num -1
+    gdb_test_multiple "frame" $test_name {
+	-re "#(\[0-9\]+) .*$gdb_prompt $" {
+	    set frame_num $expect_out(1,string)
+	}
+    }
+    return $frame_num
+}
+
+# Visit each frame in the stack and ensure that 'bt full' doesn't
+# change the selected stack frame.
+for {set i 0} {$i < 3} {incr i} {
+    if { $i == 0 } {
+	gdb_assert {[get_current_frame_number] == $i} "check frame $i is selected"
+    } else {
+	gdb_test "frame $i" "#$i .*" "select frame $i"
+    }
+
+    gdb_test "bt full" "#0 \[^\n\r\]+\[\n\r\]+No locals\.\[\n\r\]+#1 \[^\n\r\]+\[\n\r\]+No locals\.\[\n\r\]+#2 \[^\n\r\]+\[\n\r\]+No locals\.\[\n\r\]+" \
+	"perform 'bt full' in frame $i"
+
+    gdb_assert {[get_current_frame_number] == $i} "check frame $i is still selected"
+}
+